PAL trending: Trending line
[csit.git] / bootstrap-verify-perf.sh
1 #!/bin/bash
2 # Copyright (c) 2017 Cisco and/or its affiliates.
3 # Licensed under the Apache License, Version 2.0 (the "License");
4 # you may not use this file except in compliance with the License.
5 # You may obtain a copy of the License at:
6 #
7 #     http://www.apache.org/licenses/LICENSE-2.0
8 #
9 # Unless required by applicable law or agreed to in writing, software
10 # distributed under the License is distributed on an "AS IS" BASIS,
11 # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
12 # See the License for the specific language governing permissions and
13 # limitations under the License.
14
15 set -x
16
17 # Space separated list of available testbeds, described by topology files
18 TOPOLOGIES="topologies/available/lf_testbed1.yaml \
19             topologies/available/lf_testbed2.yaml \
20             topologies/available/lf_testbed3.yaml"
21
22 SCRIPT_DIR="$( cd "$( dirname "${BASH_SOURCE[0]}" )" && pwd )"
23
24 # Reservation dir
25 RESERVATION_DIR="/tmp/reservation_dir"
26 INSTALLATION_DIR="/tmp/install_dir"
27
28 PYBOT_ARGS="-W 150 -L TRACE"
29
30 JOB_ARCHIVE_ARTIFACTS=(log.html output.xml report.html output_perf_data.xml)
31 LOG_ARCHIVE_ARTIFACTS=(output.xml)
32 LOG_ARCHIVES_DIR="$WORKSPACE/archives"
33 mkdir -p ${LOG_ARCHIVES_DIR}
34
35 # If we run this script from CSIT jobs we want to use stable vpp version
36 if [[ ${JOB_NAME} == csit-* ]] ;
37 then
38     mkdir vpp_download
39     cd vpp_download
40
41     if [[ ${TEST_TAG} == *DAILY ]] || \
42        [[ ${TEST_TAG} == *WEEKLY ]];
43     then
44         # Download the latest VPP build .deb install packages
45         echo Downloading VPP packages...
46         bash ${SCRIPT_DIR}/resources/tools/scripts/download_install_vpp_pkgs.sh --skip-install
47
48         VPP_DEBS="$( readlink -f *.deb | tr '\n' ' ' )"
49         # Take vpp package and get the vpp version
50         VPP_STABLE_VER="$( expr match $(ls *.deb | head -n 1) 'vpp-\(.*\)-deb.deb' )"
51     else
52         DPDK_STABLE_VER=$(cat ${SCRIPT_DIR}/DPDK_STABLE_VER)_amd64
53         VPP_REPO_URL=$(cat ${SCRIPT_DIR}/VPP_REPO_URL_UBUNTU)
54         VPP_STABLE_VER=$(cat ${SCRIPT_DIR}/VPP_STABLE_VER_UBUNTU)
55         VPP_CLASSIFIER="-deb"
56         # Download vpp build from nexus and set VPP_DEBS variable
57         wget -q "${VPP_REPO_URL}/vpp/${VPP_STABLE_VER}/vpp-${VPP_STABLE_VER}${VPP_CLASSIFIER}.deb" || exit
58         wget -q "${VPP_REPO_URL}/vpp-dbg/${VPP_STABLE_VER}/vpp-dbg-${VPP_STABLE_VER}${VPP_CLASSIFIER}.deb" || exit
59         wget -q "${VPP_REPO_URL}/vpp-dev/${VPP_STABLE_VER}/vpp-dev-${VPP_STABLE_VER}${VPP_CLASSIFIER}.deb" || exit
60         wget -q "${VPP_REPO_URL}/vpp-dpdk-dkms/${DPDK_STABLE_VER}/vpp-dpdk-dkms-${DPDK_STABLE_VER}${VPP_CLASSIFIER}.deb" || exit
61         wget -q "${VPP_REPO_URL}/vpp-lib/${VPP_STABLE_VER}/vpp-lib-${VPP_STABLE_VER}${VPP_CLASSIFIER}.deb" || exit
62         wget -q "${VPP_REPO_URL}/vpp-plugins/${VPP_STABLE_VER}/vpp-plugins-${VPP_STABLE_VER}${VPP_CLASSIFIER}.deb" || exit
63         VPP_DEBS="$( readlink -f *.deb | tr '\n' ' ' )"
64     fi
65
66     cd ..
67
68 # If we run this script from vpp project we want to use local build
69 elif [[ ${JOB_NAME} == vpp-* ]] ;
70 then
71     # Use local packages provided as argument list
72     # Jenkins VPP deb paths (convert to full path)
73     VPP_DEBS="$( readlink -f $@ | tr '\n' ' ' )"
74     # Take vpp package and get the vpp version
75     VPP_STABLE_VER="$( expr match $1 'vpp-\(.*\)-deb.deb' )"
76 else
77     echo "Unable to identify job type based on JOB_NAME variable: ${JOB_NAME}"
78     exit 1
79 fi
80
81 WORKING_TOPOLOGY=""
82 export PYTHONPATH=${SCRIPT_DIR}
83
84 sudo apt-get -y update
85 sudo apt-get -y install libpython2.7-dev python-virtualenv
86
87 virtualenv --system-site-packages env
88 . env/bin/activate
89
90 echo pip install
91 pip install -r requirements.txt
92
93 # We iterate over available topologies and wait until we reserve topology
94 while :; do
95     for TOPOLOGY in ${TOPOLOGIES};
96     do
97         python ${SCRIPT_DIR}/resources/tools/scripts/topo_reservation.py -t ${TOPOLOGY}
98         if [ $? -eq 0 ]; then
99             WORKING_TOPOLOGY=${TOPOLOGY}
100             echo "Reserved: ${WORKING_TOPOLOGY}"
101             break
102         fi
103     done
104
105     if [ ! -z "${WORKING_TOPOLOGY}" ]; then
106         # Exit the infinite while loop if we made a reservation
107         break
108     fi
109
110     # Wait ~3minutes before next try
111     SLEEP_TIME=$[ ( $RANDOM % 20 ) + 180 ]s
112     echo "Sleeping ${SLEEP_TIME}"
113     sleep ${SLEEP_TIME}
114 done
115
116 function cancel_all {
117     python ${SCRIPT_DIR}/resources/tools/scripts/topo_installation.py -c -d ${INSTALLATION_DIR} -t $1
118     python ${SCRIPT_DIR}/resources/tools/scripts/topo_reservation.py -c -t $1
119 }
120
121 # On script exit we cancel the reservation and installation and delete all vpp
122 # packages
123 trap "cancel_all ${WORKING_TOPOLOGY}" EXIT
124
125 python ${SCRIPT_DIR}/resources/tools/scripts/topo_installation.py -t ${WORKING_TOPOLOGY} \
126                                                        -d ${INSTALLATION_DIR} \
127                                                        -p ${VPP_DEBS}
128 if [ $? -eq 0 ]; then
129     echo "VPP Installed on hosts from: ${WORKING_TOPOLOGY}"
130 else
131     echo "Failed to copy vpp deb files to DUTs"
132     exit 1
133 fi
134
135 case "$TEST_TAG" in
136     # run specific performance tests based on jenkins job type variable
137     PERFTEST_DAILY )
138         pybot ${PYBOT_ARGS} \
139               -v TOPOLOGY_PATH:${WORKING_TOPOLOGY} \
140               -s "tests.vpp.perf" \
141               --include ndrdiscANDnic_intel-x520-da2AND1t1cORndrdiscANDnic_intel-x520-da2AND2t2c \
142               --include ndrdiscAND1t1cANDipsecORndrdiscAND2t2cANDipsec \
143               tests/
144         RETURN_STATUS=$(echo $?)
145         for i in ${LOG_ARCHIVE_ARTIFACTS[@]}; do
146             cp $( readlink -f ${i} | tr '\n' ' ' ) ${LOG_ARCHIVES_DIR}/${i}.log
147         done
148         ;;
149     PERFTEST_SEMI_WEEKLY )
150         pybot ${PYBOT_ARGS} \
151               -v TOPOLOGY_PATH:${WORKING_TOPOLOGY} \
152               -s "tests.vpp.perf" \
153               --include ndrdiscANDnic_intel-x710AND1t1cORndrdiscANDnic_intel-x710AND2t2cORndrdiscANDnic_intel-xl710AND1t1cORndrdiscANDnic_intel-xl710AND2t2c \
154               tests/
155         RETURN_STATUS=$(echo $?)
156         for i in ${LOG_ARCHIVE_ARTIFACTS[@]}; do
157             cp $( readlink -f ${i} | tr '\n' ' ' ) ${LOG_ARCHIVES_DIR}/${i}.log
158         done
159         ;;
160     VERIFY-PERF-NDRDISC )
161         pybot ${PYBOT_ARGS} \
162               -v TOPOLOGY_PATH:${WORKING_TOPOLOGY} \
163               -s "tests.vpp.perf" \
164               --include ndrdiscAND1t1cORndrdiscAND2t2c \
165               tests/
166         RETURN_STATUS=$(echo $?)
167         ;;
168     VERIFY-PERF-PDRDISC )
169         pybot ${PYBOT_ARGS} \
170               -v TOPOLOGY_PATH:${WORKING_TOPOLOGY} \
171               -s "tests.vpp.perf" \
172               --include pdrdiscAND1t1cORpdrdiscAND2t2c \
173               tests/
174         RETURN_STATUS=$(echo $?)
175         ;;
176     VERIFY-PERF-MRR )
177         pybot ${PYBOT_ARGS} \
178               -v TOPOLOGY_PATH:${WORKING_TOPOLOGY} \
179               -s "tests.vpp.perf" \
180               --include mrrAND1t1cORmrrAND2t2c \
181               tests/
182         RETURN_STATUS=$(echo $?)
183         ;;
184     PERFTEST_MRR_DAILY )
185         pybot ${PYBOT_ARGS} \
186               -v TOPOLOGY_PATH:${WORKING_TOPOLOGY} \
187               -s "tests.vpp.perf" \
188               --include mrrAND64bAND1t1c \
189               --include mrrAND64bAND2t2c \
190               --include mrrAND64bAND4t4c \
191               --include mrrAND78bAND1t1c \
192               --include mrrAND78bAND2t2c \
193               --include mrrAND78bAND4t4c \
194               tests/
195         RETURN_STATUS=$(echo $?)
196         for i in ${LOG_ARCHIVE_ARTIFACTS[@]}; do
197             cp $( readlink -f ${i} | tr '\n' ' ' ) ${LOG_ARCHIVES_DIR}/${i}.log
198         done
199         ;;
200     VERIFY-PERF-IP4 )
201         pybot ${PYBOT_ARGS} \
202               -v TOPOLOGY_PATH:${WORKING_TOPOLOGY} \
203               -s "tests.vpp.perf" \
204               --include ndrdiscANDnic_intel-x520-da2AND1t1cANDip4baseORndrdiscANDnic_intel-x520-da2AND1t1cANDip4fwdANDfib_2m \
205               tests/
206         RETURN_STATUS=$(echo $?)
207         ;;
208     VERIFY-PERF-IP6 )
209         pybot ${PYBOT_ARGS} \
210               -v TOPOLOGY_PATH:${WORKING_TOPOLOGY} \
211               -s "tests.vpp.perf" \
212               --include ndrdiscANDnic_intel-x520-da2AND1t1cANDip6baseORndrdiscANDnic_intel-x520-da2AND1t1cANDip6fwdANDfib_2m \
213               tests/
214         RETURN_STATUS=$(echo $?)
215         ;;
216     VERIFY-PERF-L2 )
217         pybot ${PYBOT_ARGS} \
218               -v TOPOLOGY_PATH:${WORKING_TOPOLOGY} \
219               -s "tests.vpp.perf" \
220               --include ndrdiscANDnic_intel-x520-da2AND1t1cANDl2xcbaseORndrdiscANDnic_intel-x520-da2AND1t1cANDl2bdbase \
221               tests/
222         RETURN_STATUS=$(echo $?)
223         ;;
224     VERIFY-PERF-LISP )
225         pybot ${PYBOT_ARGS} \
226               -v TOPOLOGY_PATH:${WORKING_TOPOLOGY} \
227               -s "tests.vpp.perf" \
228               --include ndrdiscANDnic_intel-x520-da2AND1t1cANDlisp \
229               tests/
230         RETURN_STATUS=$(echo $?)
231         ;;
232     VERIFY-PERF-VXLAN )
233         pybot ${PYBOT_ARGS} \
234               -v TOPOLOGY_PATH:${WORKING_TOPOLOGY} \
235               -s "tests.vpp.perf" \
236               --include ndrdiscANDnic_intel-x520-da2AND1t1cANDvxlan \
237               tests/
238         RETURN_STATUS=$(echo $?)
239         ;;
240     VERIFY-PERF-VHOST )
241         pybot ${PYBOT_ARGS} \
242               -v TOPOLOGY_PATH:${WORKING_TOPOLOGY} \
243               -s "tests.vpp.perf" \
244               --include ndrdiscANDnic_intel-x520-da2AND1t1cANDvhost \
245               tests/
246         RETURN_STATUS=$(echo $?)
247         ;;
248     VERIFY-PERF-MEMIF )
249         pybot ${PYBOT_ARGS} \
250               -v TOPOLOGY_PATH:${WORKING_TOPOLOGY} \
251               -s "tests.vpp.perf" \
252               --include ndrdiscANDnic_intel-x520-da2AND1t1cANDmemif \
253               tests/
254         RETURN_STATUS=$(echo $?)
255         ;;
256     VERIFY-PERF-IPSECHW )
257         pybot ${PYBOT_ARGS} \
258               -v TOPOLOGY_PATH:${WORKING_TOPOLOGY} \
259               -s "tests.vpp.perf.crypto" \
260               --include ndrdiscANDnic_intel-xl710AND1t1cANDipsechw \
261               --include ndrdiscANDnic_intel-xl710AND2t2cANDipsechw \
262               tests/
263         ;;
264     VPP-VERIFY-PERF-IP4 )
265         pybot ${PYBOT_ARGS} \
266               -v TOPOLOGY_PATH:${WORKING_TOPOLOGY} \
267               -s "tests.vpp.perf" \
268               --include mrrANDnic_intel-x520-da2AND1t1cANDip4baseORmrrANDnic_intel-x520-da2AND1t1cANDip4fwdANDfib_2m \
269               tests/
270         RETURN_STATUS=$(echo $?)
271         ;;
272     VPP-VERIFY-PERF-IP6 )
273         pybot ${PYBOT_ARGS} \
274               -v TOPOLOGY_PATH:${WORKING_TOPOLOGY} \
275               -s "tests.vpp.perf" \
276               --include mrrANDnic_intel-x520-da2AND1t1cANDip6baseORmrrANDnic_intel-x520-da2AND1t1cANDip6fwdANDfib_2m \
277               tests/
278         RETURN_STATUS=$(echo $?)
279         ;;
280     VPP-VERIFY-PERF-L2 )
281         pybot ${PYBOT_ARGS} \
282               -v TOPOLOGY_PATH:${WORKING_TOPOLOGY} \
283               -s "tests.vpp.perf" \
284               --include mrrANDnic_intel-x520-da2AND1t1cANDl2xcbaseORmrrANDnic_intel-x520-da2AND1t1cANDl2bdbase \
285               tests/
286         RETURN_STATUS=$(echo $?)
287         ;;
288     VPP-VERIFY-PERF-LISP )
289         pybot ${PYBOT_ARGS} \
290               -v TOPOLOGY_PATH:${WORKING_TOPOLOGY} \
291               -s "tests.vpp.perf" \
292               --include pdrchkANDnic_intel-x520-da2AND1t1cANDlisp \
293               tests/
294         RETURN_STATUS=$(echo $?)
295         ;;
296     VPP-VERIFY-PERF-VXLAN )
297         pybot ${PYBOT_ARGS} \
298               -v TOPOLOGY_PATH:${WORKING_TOPOLOGY} \
299               -s "tests.vpp.perf" \
300               --include pdrchkANDnic_intel-x520-da2AND1t1cANDvxlan \
301               tests/
302         RETURN_STATUS=$(echo $?)
303         ;;
304     VPP-VERIFY-PERF-VHOST )
305         pybot ${PYBOT_ARGS} \
306               -v TOPOLOGY_PATH:${WORKING_TOPOLOGY} \
307               -s "tests.vpp.perf" \
308               --include pdrdiscANDnic_intel-x520-da2AND1t1cANDvhost \
309               tests/
310         RETURN_STATUS=$(echo $?)
311         ;;
312     VPP-VERIFY-PERF-MEMIF )
313         pybot ${PYBOT_ARGS} \
314               -v TOPOLOGY_PATH:${WORKING_TOPOLOGY} \
315               -s "tests.vpp.perf" \
316               --include pdrdiscANDnic_intel-x520-da2AND1t1cANDmemif \
317               --include pdrdiscANDnic_intel-x520-da2AND2t2cANDmemif \
318               --include mrrANDnic_intel-x520-da2AND1t1cANDmemif \
319               --include mrrANDnic_intel-x520-da2AND2t2cANDmemif \
320               tests/
321         RETURN_STATUS=$(echo $?)
322         ;;
323     VPP-VERIFY-PERF-ACL )
324         pybot ${PYBOT_ARGS} \
325               -v TOPOLOGY_PATH:${WORKING_TOPOLOGY} \
326               -s "tests.vpp.perf" \
327               --include pdrdiscANDnic_intel-x520-da2AND1t1cANDacl \
328               --include pdrdiscANDnic_intel-x520-da2AND2t2cANDacl \
329               tests/
330         RETURN_STATUS=$(echo $?)
331         ;;
332     VPP-VERIFY-PERF-IPSECHW )
333         pybot ${PYBOT_ARGS} \
334               -v TOPOLOGY_PATH:${WORKING_TOPOLOGY} \
335               -s "tests.vpp.perf.crypto" \
336               --include pdrdiscANDnic_intel-xl710AND1t1cANDipsechw \
337               --include pdrdiscANDnic_intel-xl710AND2t2cANDipsechw \
338               tests/
339         RETURN_STATUS=$(echo $?)
340         ;;
341     PERFTEST_LONG )
342         pybot ${PYBOT_ARGS} \
343               -v TOPOLOGY_PATH:${WORKING_TOPOLOGY} \
344               -s "tests.vpp.perf" \
345               --exclude SKIP_PATCH \
346               -i NDRPDRDISC \
347               tests/
348         RETURN_STATUS=$(echo $?)
349         ;;
350     PERFTEST_SHORT )
351         pybot ${PYBOT_ARGS} \
352               -v TOPOLOGY_PATH:${WORKING_TOPOLOGY} \
353               -s "tests.vpp.perf" \
354               -i MRR \
355               tests/
356         RETURN_STATUS=$(echo $?)
357         ;;
358     * )
359         # run full performance test suite and exit on fail
360         pybot ${PYBOT_ARGS} \
361               -v TOPOLOGY_PATH:${WORKING_TOPOLOGY} \
362               -s "tests.vpp.perf" \
363               tests/
364         RETURN_STATUS=$(echo $?)
365 esac
366
367 # Pybot output post-processing
368 echo Post-processing test data...
369
370 python ${SCRIPT_DIR}/resources/tools/scripts/robot_output_parser.py \
371        -i ${SCRIPT_DIR}/output.xml \
372        -o ${SCRIPT_DIR}/output_perf_data.xml \
373        -v ${VPP_STABLE_VER}
374 if [ ! $? -eq 0 ]; then
375     echo "Parsing ${SCRIPT_DIR}/output.xml failed"
376 fi
377
378 # Archive artifacts
379 mkdir -p archive
380 for i in ${JOB_ARCHIVE_ARTIFACTS[@]}; do
381     cp $( readlink -f ${i} | tr '\n' ' ' ) archive/
382 done
383
384 echo Post-processing finished.
385
386 exit ${RETURN_STATUS}